/*  lil-gp Genetic Programming System, version 1.0, 11 July 1995
 *  Copyright (C) 1995  Michigan State University
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of version 2 of the GNU General Public License as
 *  published by the Free Software Foundation.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  Douglas Zongker       (zongker@isl.cps.msu.edu)
 *  Dr. Bill Punch        (punch@isl.cps.msu.edu)
 *
 *  Computer Science Department
 *  A-714 Wells Hall
 *  Michigan State University
 *  East Lansing, Michigan  48824
 *  USA
 *  
 */

#ifndef _APPDEF_H
#define _APPDEF_H

/* define MAXARGS to the maximum number of arguments passed to any function. */
#define MAXARGS   3

/* define DATATYPE to be the type returned by the functions and terminals. */
#define DATATYPE char *

/* define C_MAJOR if you want to use the C Major scale rather than all notes */
#define C_MAJOR

/* define CHORDS if you want to have pseudo-chord terminals */
#define CHORDS

/* here you should create a typedef struct called "globaldata" to pass
 * information between the evaluation C function and the functions and
 * terminals (if that is needed by your application).
 */
typedef struct
{

  FD_Main *fd_Main;   /* the xform for simple rating */
  FD_List *fd_List;   /* the xform for listed group rating */
  FD_Tourn *fd_Tourn; /* the xform for tournament rating */
  /* information you need to pass around goes here. */

} globaldata;


#endif
