#ifndef _AUTO_RATERS_H_

#define _AUTO_RATERS_H_

/*
 * InitListRater - initializes the list rater network using the parameters,
 *   weights and biases found in weightFileName.  Note that either the list
 *   rater or the tournament rater can be initialized, but not both.
 */
void InitListRater(const char *weightFileName);

/*
 * InitTournRater - initializes the list rater network using the parameters,
 *   weights and biases found in weightFileName.  Note that either the list
 *   rater or the tournament rater can be initialized, but not both.
 */
void InitTournRater(const char *weightFileName);

/*
 * tAutoRate - gives the neural nets answer to whether sequence1 is worse than
 *   sequence2.  A result of less than 0.5 indicates that it is worse, and
 *   greater than 0.5 indicates that sequence1 is better.
 */
double tAutoRate(const char *sequence1, const char *sequence2);

/*
 * lAutoRate - gives the neural nets rating for aSequence.  The answer varies
 *   varies between 0 and 1, with 1 being the best.
 */
double lAutoRate(const char *aSequence);

/*
 * uninitRaters - frees all memory used by the raters
 */
void uninitRaters();

#endif
