#ifndef FD_List_h_
#define FD_List_h_
/* Header file generated with fdesign. */

/**** Callback routines ****/

extern void ind_selected(FL_OBJECT *, long);
extern void ind_rater(FL_OBJECT *, long);
extern void play_indiv(FL_OBJECT *, long);
extern void delta_select_ind(FL_OBJECT *, long);
extern void delta_rater(FL_OBJECT *, long);

/**** Forms and Objects ****/

typedef struct {
	FL_FORM *List;
	void *vdata;
	long ldata;
	FL_OBJECT *Indiv_Browser;
	FL_OBJECT *Ind_Rate_Slider;
	FL_OBJECT *Play_Button;
	FL_OBJECT *Gen_Number;
	FL_OBJECT *Ind_Number;
	FL_OBJECT *Next_Gen_Button;
	FL_OBJECT *Exit_Button;
	FL_OBJECT *Seq_Text;
	FL_OBJECT *Prev_Button;
	FL_OBJECT *Next_Button;
	FL_OBJECT *Inc_Rater;
	FL_OBJECT *Dec_Rater;
} FD_List;

extern FD_List * create_form_List(void);

/**** Structures ****/

#define DATATYPE char *

/*
 * Structure for noteSequences and their ratings
 */
typedef struct
{
  DATATYPE noteSequence;
  char *melodyString;
  double rating;
  int isRated;      /* set to '1' if this sequence has been rated */
  int isSuggestion; /* set to '1' if this is a suggested rating */
  
} Melody;

/*
 * Structure for information needed by the lister
 */
typedef struct
{
  int maxInd;
  int maxGen;
  Melody *melArray;
  int currentInd;

} ListerInfo;

/**** Common Routines ****/
extern void set_melody(FL_OBJECT *browser, Melody *ind, \
			   int indNumber); 

#endif /* FD_List_h_ */
