#include "forms.h"
#include "gp-list.h"

int main(int argc, char *argv[])
{
   FD_List *fd_List;
   char aSequence[1000] = "(A#2) (   ) (D-5) (F#3) (   ) (   )\n(B-6) " \
     "(A#2) (   ) (D-5) (F#3) (   )\n(   ) (B-6) " \
     "(A#2) (   ) (D-5) (F#3)\n(   ) (   ) (B-6) " \
     "(A#2) (   ) (D-5)\n(F#3) (   ) (   ) (B-6)";
   /* line break every 26 chars or 6 notes */
   
   Melody *melArray;
   FL_OBJECT *theBrowser;
   int maxInd=16;
   int maxGen=5;
   int i,j;
   char tempString[50];
   int cont=1;
   
   fl_initialize(&argc, argv, 0, 0, 0);
   fd_List = create_form_List();

   /* initialize the array for test */
   melArray=(Melody *)malloc(maxInd*sizeof(Melody));

   for(i=0;i<maxInd;i++) {
     melArray[i].melodyString=aSequence;
     melArray[i].noteSequence=NULL;
     melArray[i].rating=i;
     melArray[i].isRated=0;
     melArray[i].isSuggestion=0;
   }

   /* initialize the ListerInfo */
   fd_List->vdata=(void *)malloc(sizeof(ListerInfo));
   ((ListerInfo *)(fd_List->vdata))->melArray=melArray;
   ((ListerInfo *)(fd_List->vdata))->maxInd=maxInd;;
   ((ListerInfo *)(fd_List->vdata))->maxGen=maxGen;
   
   /*
    * initialize the form and other stuff
    */
   theBrowser=fd_List->Indiv_Browser;

   /* set the browser, rater and play button object to point back
      to the main form */
   theBrowser->u_vdata=(void *)fd_List;
   fd_List->Ind_Rate_Slider->u_vdata=(void *)fd_List;
   fd_List->Play_Button->u_vdata=(void *)fd_List;
   fd_List->Prev_Button->u_vdata=(void *)fd_List;
   fd_List->Next_Button->u_vdata=(void *)fd_List;
   fd_List->Inc_Rater->u_vdata=(void *)fd_List;
   fd_List->Dec_Rater->u_vdata=(void *)fd_List;
   
   /* put an entry in text box for each Melody */
   for(i=0;i<maxInd;i++)
       fl_add_browser_line(theBrowser, "Melody ??");
        
   j=0;

   fl_show_form(fd_List->List,FL_PLACE_CENTER,FL_FULLBORDER,"GP-Music" \
		  " Generation Rater");

   /*
    * Now do stuff
    */
   do {

     /* freeze the form for modifications */
     fl_freeze_form(fd_List->List);

     /* Somehow update the melArray from new gen */
     
     /* for each Melody put it into the Melody list box */
     for(i=0;i<maxInd;i++)
       set_melody(theBrowser, &(melArray[i]), i);
          
     /* Now display the first Melody */
     fl_select_browser_line(theBrowser, 1);
     fl_call_object_callback(theBrowser);
     
     /* Set the generation number */
     sprintf(tempString, "%d/%d", j, maxGen);
     fl_set_object_label(fd_List->Gen_Number, tempString);
          
     /* unfreeze the list form */
     fl_unfreeze_form(fd_List->List);

     /* let the user interact, but make sure the generation is completely
	rated */
     if(fl_do_forms() == fd_List->Next_Gen_Button) {

       for(i=0;i<maxInd;i++)
	 if(melArray[i].isRated == 0) {
	   fl_show_alert("Error: ","All Melodies must be rated!!","",1);
	   break;
	 }

       if(i==maxInd) j++;

       if(j>maxGen) cont=0;
       
     } else cont=0;
        
} while ( cont );
   
   return 0;
}
