#ifndef FD_Main_h_
#define FD_Main_h_

/* Header file generated with fdesign. */

/**** Callback routines ****/
extern void ind_selected(FL_OBJECT *, long);
extern void ind_rater(FL_OBJECT *, long);
extern void play_indiv(FL_OBJECT *, long);
extern void delta_select_ind(FL_OBJECT *, long);
extern void delta_rater(FL_OBJECT *, long);
extern void dummy(FL_OBJECT *, long);
extern void delta_tourn_rater(FL_OBJECT *, long);

/**** Forms and Objects ****/

typedef struct {
	FL_FORM *Main;
	FL_OBJECT *Gen_Number;
	FL_OBJECT *Ind_Number;
	FL_OBJECT *Ind_Rate_Slider;
	FL_OBJECT *Play_Button;
	FL_OBJECT *Next_Song_Button;
	FL_OBJECT *Exit_Button;
	void *vdata;
	long ldata;
} FD_Main;

extern FD_Main * create_form_Main(void);

typedef struct {
	FL_FORM *List;
	void *vdata;
	long ldata;
	FL_OBJECT *Indiv_Browser;
	FL_OBJECT *Ind_Rate_Slider;
	FL_OBJECT *Play_Button;
	FL_OBJECT *Gen_Number;
	FL_OBJECT *Ind_Number;
	FL_OBJECT *Next_Gen_Button;
	FL_OBJECT *Exit_Button;
	FL_OBJECT *Seq_Text;
	FL_OBJECT *Prev_Button;
	FL_OBJECT *Next_Button;
	FL_OBJECT *Inc_Rater;
	FL_OBJECT *Dec_Rater;
} FD_List;

extern FD_List * create_form_List(void);

typedef struct {
	FL_FORM *Tourn;
	void *vdata;
	long ldata;
	FL_OBJECT *Gen_Number;
	FL_OBJECT *Ind_Number;
	FL_OBJECT *Next_Comp_Button;
	FL_OBJECT *Exit_Button;
	FL_OBJECT *Play_Button_2;
	FL_OBJECT *Play_Button_1;
	FL_OBJECT *Ind_Rater;
	FL_OBJECT *Inc_Button;
	FL_OBJECT *Dec_Button;
	FL_OBJECT *Song1_Browser;
	FL_OBJECT *Song2_Browser;
} FD_Tourn;

extern FD_Tourn * create_form_Tourn(void);

/**** Structures ****/

#ifndef DATATYPE
#define DATATYPE char *
#define TEMDATATYPE
#endif

/*
 * Structure for noteSequences and their ratings
 */
typedef struct
{
  DATATYPE noteSequence;
  char *melodyString;
  double rating;
  int isRated;      /* set to '1' if this sequence has been rated */
  int isSuggestion; /* set to '1' if this is a suggested rating */
  
} Melody;

/*
 * Structure for information needed by the lister
 */
typedef struct
{
  int maxInd;
  Melody *melArray;
  int currentInd;

} ListerInfo;

/**** Common Routines ****/
extern void set_melody(FL_OBJECT *browser, Melody *ind, \
			   int indNumber); 

#ifdef TEMPDATATYPE
#undef DATATYPE
#undef TEMPDATATYPE
#endif

#endif /* FD_Main_h_ */



