#include <stdio.h>
#include <string.h>
#include "xm_lib.h"

int main ( int argc, char **argv ) {

  int i;
  int j;
  int maxGen, maxInd;
  FILE *ratingLog;
  size_t temp;
  char *noteSequence;
  char *melodyString;
  double rating;
  
  /* open the rating file */
  ratingLog=fopen(argv[1],"r");

  /* get the number of individuals and generations */
  fread(&maxGen, sizeof(int), 1, ratingLog);
  fread(&maxInd, sizeof(int), 1, ratingLog);  

  printf("GP-Music Ratings\n\n%d generations with %d "
	 "individuals per generation\n\n", maxGen, maxInd);

  noteSequence=(char *)malloc(4*sizeof(char));
  
  /* now print the each generation and their individuals */
  for(i=0;i<=maxGen;i++) {

    printf("Generation %d:\n\n", i);
    
    for(j=0;j<maxInd;j++) {

      /* read size of sequence */
      fread(&temp, sizeof(size_t), 1, ratingLog);
        
      /* allocate and read note sequence */
      noteSequence=(char *)realloc(noteSequence, temp*sizeof(char));
      fread(noteSequence, sizeof(char), temp, ratingLog);

      /* print the sequence */
      melodyString=sprintNoteSequence(noteSequence);
      printf("%s\n",melodyString);
      
      /* read rating */
      fread(&rating, sizeof(double), 1, ratingLog);
      printf("Rating:\t%lg\n\n", rating);

      /* now print info */
      printf("-----------------------------------\n");
      printf("Individual:\t%d\tRating:\t%lg\n\n%s\n", j, rating,
	     melodyString);
      free(melodyString);
       
    }

    printf("-----------------------------------\n");
    
  }

  /* free the noteSequence */
  free(noteSequence);
  
  /* close the rating file */
  fclose(ratingLog);
    
}
