#ifndef _RATE_CONFIG_H_
#define _RATE_CONFIG_H_

/*
 * Defines the level spreads for the list auto rater
 *
 *   The spread of the top level integrator will be adjusted to accept
 *   the maximum number of inputs from level 3 given the maximimum sequence
 *   length is L_MAX_LENGTH.
 */
#define L_ONE_SPREAD 8
#define L_ONE_DELTA 4
#define L_TWO_SPREAD 8
#define L_TWO_DELTA 4
#define L_THREE_SPREAD 4
#define L_THREE_DELTA 2
#define L_MAX_LENGTH 200

/*
 * Defines the level spreads for the tournament auto rater
 *
 *   The spread of the top level integrator will be adjusted to accept
 *   the maximum number of inputs from level 3 given the maximimum sequence
 *   length is T_MAX_LENGTH.
 *
 *   Note also that the spreads are per melody, so there will actually be
 *   two sets of connections with the given spread width and deltas.
 */
#define T_ONE_SPREAD 8
#define T_ONE_DELTA 4
#define T_TWO_SPREAD 8
#define T_TWO_DELTA 4
#define T_THREE_SPREAD 4
#define T_THREE_DELTA 2
#define T_MAX_LENGTH 200


#endif
