#include <stdio.h>
#include <string.h>

int main ( int argc, char **argv ) {

  int i,j;
  int maxGen, maxInd;
  FILE *ratingLog;
  FILE **outFiles;        /* array of output files */
  int currentOutFile;    /* points to the output file for the next ind */
  int *fileNumInds;      /* stores the number of inds in each output file */
  size_t temp;
  char tempString[100];
  int splitNum;
  char *noteSequence;
  double rating;
  
  /* open the rating file */
  ratingLog=fopen(argv[2],"r");

  /* find the number of pieces to split into */
  splitNum=atoi(argv[1]);
  
  /* open the output files */
  outFiles=(FILE **)malloc(splitNum*sizeof(FILE *));
  fileNumInds=(int *)malloc(splitNum*sizeof(int));
  for(i=0;i<splitNum;i++) {
    sprintf(tempString,"%d%s",i,argv[2]);
    outFiles[i]=fopen(tempString,"w+");
    fwrite(&i, sizeof(int), 1, outFiles[i]); /* make space for an int */
    fileNumInds[i]=0;
  }
  currentOutFile=0;
    
  /* get the number of individuals and generations */
  fread(&maxGen, sizeof(int), 1, ratingLog);
  fread(&maxInd, sizeof(int), 1, ratingLog);  

  printf("Splitting GP-Music Ratings into %d parts\n\nInput file has "
	 "%d generations with %d "
	 "individuals per generation\n\n", splitNum, maxGen, maxInd);

  noteSequence=(char *)malloc(4*sizeof(char));
  
  /* now loop through generations and individuals */
  for(i=0;i<=maxGen;i++)
    for(j=0;j<maxInd;j++) {

      /* read size of sequence */
      fread(&temp, sizeof(size_t), 1, ratingLog);

      /* write the size of the sequence */
      fwrite(&temp, sizeof(size_t), 1, outFiles[currentOutFile]);
      
      /* allocate and read note sequence */
      noteSequence=(char *)realloc(noteSequence, temp*sizeof(char));
      fread(noteSequence, sizeof(char), temp, ratingLog);

      /* save the note sequence to the current output file */
      fwrite(noteSequence, sizeof(char), temp, outFiles[currentOutFile]);
	     
      /* read rating */
      fread(&rating, sizeof(double), 1, ratingLog);
      
      /* save the rating to the current output file */
      fwrite(&rating, sizeof(double), 1, outFiles[currentOutFile]);
      
      /* change to the next output file and increment fileNumInds */
      fileNumInds[currentOutFile]++;
      currentOutFile=(currentOutFile+1)%splitNum;
      
    }

  /* free the noteSequence */
  free(noteSequence);
  
  /* close the rating file */
  fclose(ratingLog);

  /* write the number of individuals into each output file and close them */
  for(i=0;i<splitNum;i++) {
    fseek(outFiles[i], 0, SEEK_SET);
    fwrite(&(fileNumInds[i]), sizeof(int), 1, outFiles[i]);
    fclose(outFiles[i]);
  }
  
  /* deallocate arrays */
  free(outFiles);
  free(fileNumInds);

  exit(0);
  
}


